/*
* dir_proc.c: remote readdir implementation
*/

#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "dir.h"    /* Created by rpcgen */
extern int errno;

readdir_res *readdir_1_svc(nametype *dirname, struct svc_req *req)
{
    DIR *dirp;
    struct dirent *d;
    namelist nl;
    namelist *nlp;
    static readdir_res res; /* must be static! */

    /* Open directory */
    dirp = opendir(*dirname);
    if (dirp == (DIR *)NULL) {
        res.remoteErrno = errno;
        return(&res);
    }
    /* Free previous result */
    xdr_free((xdrproc_t)xdr_readdir_res, (char *)&res);
    /*
     * Collect directory entries.
     * Memory allocated here is free by
     * xdr_free the next time readdir_1
     * is called
     */
    nlp = &res.readdir_res_u.list;
    while ((d = readdir(dirp)) != NULL) {
        nl = *nlp = (namenode *)malloc(sizeof(namenode));
        if (nl == (namenode *) NULL) {
            res.remoteErrno = EAGAIN;
            closedir(dirp);
            return(&res);
        }
        nl->name = strdup(d->d_name);
        nlp = &nl->next;
    }
    *nlp = (namelist)NULL;
    /* Return the result */
    res.remoteErrno = 0;
    closedir(dirp);
    return(&res);
}
